Botan: Botan::DataSink_Stream Class Reference

Botan 1.10.12

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::DataSink_Stream Class Reference

`#include <data_snk.h>`

Inheritance diagram for Botan::DataSink_Stream:

## Public Member Functions
bool | attachable ()
| DataSink_Stream (std::ostream &stream, const std::string &name="<std::ostream>")
| DataSink_Stream (const std::string &pathname, bool use_binary=false)
virtual void | end_msg ()
std::string | name () const
virtual void | start_msg ()
void | write (const byte[], size_t)
| ~DataSink_Stream ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

This class represents a data sink which writes its output to a stream.

Definition at line 33 of file data_snk.h.

## Constructor & Destructor Documentation

Botan::DataSink_Stream::DataSink_Stream | ( | std::ostream & | stream,
|  | const std::string & | name = `"<std::ostream>"`
| ) |  |

Construct a DataSink_Stream from a stream.

Parameters

  stream | the stream to write to
  name | identifier

Definition at line 29 of file data_snk.cpp.

30 :
31 identifier(name),
32 sink_p(0),
33 sink(out)
34 {
35 }
Botan::DataSink_Stream::name
std::string name() const
Definition: data_snk.h:36

Botan::DataSink_Stream::DataSink_Stream | ( | const std::string & | pathname,
|  | bool | use_binary = `false`
| ) |  |

Construct a DataSink_Stream from a stream.

Parameters

  pathname | the name of the file to open a stream to
  use_binary | indicates whether to treat the file as a binary file or not

Definition at line 40 of file data_snk.cpp.

41 :
42 identifier(path),
43 sink_p(new std::ofstream(
44 path.c_str(),
45 use_binary ? std::ios::binary : std::ios::out)),
46 sink(*sink_p)
47 {
48 if(!sink.good())
49 {
50 delete sink_p;
51 throw Stream_IO_Error("DataSink_Stream: Failure opening " + path);
52 }
53 }

Botan::DataSink_Stream::~DataSink_Stream | ( |  | ) |

Definition at line 58 of file data_snk.cpp.

59 {
60 delete sink_p;
61 }

## Member Function Documentation

bool Botan::DataSink::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented from Botan::Filter.

Definition at line 22 of file data_snk.h.

22 { return false; }

virtual void Botan::Filter::end_msg | ( |  | ) |
| inlinevirtualinherited

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::PK_Verifier_Filter, Botan::Base64_Decoder, Botan::Hex_Decoder, Botan::PK_Signer_Filter, Botan::Zlib_Decompression, Botan::Bzip_Decompression, Botan::PK_Decryptor_Filter, Botan::PBE_PKCS5v20, Botan::Base64_Encoder, Botan::Hex_Encoder, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, Botan::Zlib_Compression, and Botan::PK_Encryptor_Filter.

Definition at line 44 of file filter.h.

Referenced by Botan::Filter::send().

44 {}

std::string Botan::DataSink_Stream::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 36 of file data_snk.h.

36 { return identifier; }

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Zlib_Compression::write(), Botan::Bzip_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

void Botan::DataSink_Stream::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 18 of file data_snk.cpp.

19 {
20 sink.write(reinterpret_cast<const char*>(out), length);
21 if(!sink.good())
22 throw Stream_IO_Error("DataSink_Stream: Failure writing to " +
23 identifier);
24 }

The documentation for this class was generated from the following files:

- src/filters/data_snk.h
- src/filters/data_snk.cpp